library(RColorBrewer)

#x11(width=10, height=6)
pdf("~/Documents/monday_seminar/20131118/img/affine.pdf", width=10, height=6)
op <- par(mfrow=c(1,2))

max <- 10

colors <- brewer.pal(n=5, "Set1")	
colors <- c(colors[5], colors[2], colors[2], colors[1], colors[3], colors[4])
ltys <- c(1, 1, 1, 1, 1, 1)

#Time

x <- 1:(max + 1) - 1
files  <- c("summary-100bp-time-subst.txt", "summary-100bp-time-indel.txt", "summary-time.txt")
output <- c("plots/100bp-subst-time.pdf", "plots/100bp-indel-time.pdf", "plots/100bp-distance-time.pdf")
xaxis <- c("substitutions per 100 bp", "indels per 100 bp", "divergence [%]")

#for(i in 1:length(files)) {
	#i <- 3
	#pdf(output[i], width=7, height=9)
	
	i <- 3
	y <- read.table(files[i], header=F, sep='\t')[,1:12]
	#z <- read.table("summary-100bp-distance.txt", header=TRUE, sep='\t')[,1:17]
	names <- y[,1]
	y <- y[,2:(max + 2)]	
	y <- y / 60
	#z <- z[,2:(max + 2)]
	#z <- z * 5000000	
	#z <- 5000000

	par(fig=c(0.53,0.99,0,1), oma=c(0.0, 0.0, 0.0, 0.0), mar=c(5.1, 4.5, 4.1, 0.0), new=TRUE)
	yl = "runtime [min]"
#	yl = "time for 5mio correctly mapped [min]"
#	yl = "correctly mapped per min"
	yli = c(0,100)
#	yli = c(0,200000000)
	plot(1, xlim=c(0,max),ylim=yli, main="(b)", xlab=xaxis[i], ylab=yl, axes=F,cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, type="n")

	for(i in c(1,2)) {
#		r = y[i,]/z[i,] * 5000000
#		r = z[i,]/y[i,]
		r = y[i,]
		lines(x, r, xlim=c(0,max),ylim=c(0,100), cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, col=colors[i],  lty=ltys[i], type="l")
	}
	axis(side=1, cex.axis=2.0) 
	axis(side=2, cex.axis=2.0) 

	names <- c("NGM", "NGM (affine)")
	legend(0.2,100,names, col=colors, cex=1.5, lwd=2, lty=ltys)
	#legend(3.2,200000000,names, col=colors, cex=1.5, lwd=2, lty=ltys)
	#dev.off()
#}
	
	
	
	
#Mapping results
files  <- c("summary-100bp-subst.txt", "summary-100bp-indel.txt", "summary.txt")
files2  <- c("summary-100bp-wrong-subst.txt", "summary-100bp-wrong-indel.txt", "summary-wrong.txt")
output <- c("plots/100bp-subst.pdf", "plots/100bp-indel.pdf", "plots/100bp-distance.pdf")
xaxis <- c("substitutions per 100 bp", "indels per 100 bp", "divergence [%]")

#for(i in 1:length(files)) {
	#i <- 3
	#pdf(output[i], width=7, height=9)

	i <- 3
	y <- read.table(files[i], header=F, sep='\t')[,1:12]
	names <- y[,1]
	y <- y[,2:(max + 2)]
	
	y2 <- read.table(files2[i], header=F, sep='\t')[,1:12]
	names <- y2[,1]
	y2 <- y2[,2:(max + 2)]

	par(fig=c(0,0.53,0,1), oma=c(0.0, 0.0, 0.0, 0.0), mar=c(5.1, 4.5, 4.1, 4.1), new=TRUE)
	pchars <- c(0,1,2,3,4)
	
	plot(1, xlim=c(0,max),ylim=c(0,100), main="(a)", xlab=xaxis[i], ylab="correctly mapped [%]", axes=F,cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, type="n")

	for(i in c(1,2)) {
		lines(x, y[i,], xlim=c(0,max),ylim=c(0,100), cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, col=colors[i],  lty=1, type="l")#, pch=pchars[i])
		lines(x, y2[i,], xlim=c(0,max),ylim=c(0,100), cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, col=colors[i],  lty=2, type="l")#, pch=pchars[i])
	}
	axis(side=1, cex.axis=2.0) 
	axis(side=2, cex.axis=2.0) 
	axis(side=4, lty=2, pos=(max + 0.5), cex.axis=2.0)

	mtext("incorrectly mapped [%]", side = 4, line = 3, cex=2.0)

	names <- c("ngm", "bowtie2", "bwasw", "stampy", "bwa")
	ltypes <- c(1,1,1,1,1)
	#legend(0,40,names, col=colors, lty=ltypes, cex=1.5, lwd=2)
	
	#dev.off()
#}

dev.off()


pdf(file="~/tmp/ngm_plot_100.pdf", height=7, width=9)
	
	max <- 10
	
	colors <- brewer.pal(n=5, "Set1")	
	colors <- c(colors[5], colors[5], colors[2], colors[1], colors[3], colors[4])
	ltys <- c(1, 4, 1, 1, 1, 1)


	files  <- c("summary-100bp-time-subst.txt", "summary-100bp-time-indel.txt", "summary-100bp-time-distance.txt")

	i <- 3
	time <- read.table(files[i], header=TRUE, sep='\t')[,1:17]
	names <- time[,1]
	time <- time[,2:(max + 2)]	
	time <- time / 60

	files  <- c("summary-100bp-subst.txt", "summary-100bp-indel.txt", "summary-100bp-distance.txt")
	files2  <- c("summary-100bp-wrong-subst.txt", "summary-100bp-wrong-indel.txt", "summary-100bp-wrong-distance.txt")

	i <- 3
	correct <- read.table(files[i], header=TRUE, sep='\t')[,1:17]
	names <- correct[,1]
	correct <- correct[,2:(max + 2)]
	
	b = 1
	plot(c(time[b,]), c(correct[b,]), xlim=c(0,100), ylim=c(0,100), col=colors[b], pch=48:59, xlab="time [min]", ylab="correctly mapped reads [%]")
	for(b in 2:7) {
		lines(c(time[b,]), c(correct[b,]), xlim=c(0,100), ylim=c(0,100), col=colors[b], pch=48:59, type='b')
	}
	names <- c("NGM (GPU)", "NGM (CPU)", "Bowtie2", "BWA-SW", "Stampy", "BWA")
	legend(55,45,names, col=colors, cex=1.5, lwd=2, lty=ltys)
	
dev.off()
	
	
	y2 <- read.table(files2[i], header=TRUE, sep='\t')[,1:17]
	names <- y2[,1]
	y2 <- y2[,2:(max + 2)]
