library(RColorBrewer)

x11(width=8, height=6)
#pdf("sim.pdf", width=10, height=6)
#op <- par(mfrow=c(1,2))

max <- 10

colors <- brewer.pal(n=5, "Set1")	
colors <- c(colors[5], colors[5], colors[2], colors[1], colors[3], colors[4], 'black', 'black')
ltys <- c(1, 4, 1, 1, 1, 1, 1, 1)

#Time
pdf("adb-poly-time-0.pdf", width=8, height=6)
x <- 1:(max + 1) - 1
files  <- c("summary-100bp-time-subst.txt", "summary-100bp-time-indel.txt", "summary-100bp-time-distance.txt")
output <- c("plots/100bp-subst-time.pdf", "plots/100bp-indel-time.pdf", "plots/100bp-distance-time.pdf")
xaxis <- c("substitutions per 100 bp", "indels per 100 bp", "divergence [%]")

#for(i in 1:length(files)) {
	#i <- 3
	#pdf(output[i], width=7, height=9)
	
	i <- 3
	y <- read.table(files[i], header=TRUE, sep='\t')[,1:17]
	z <- read.table("summary-100bp-distance.txt", header=TRUE, sep='\t')[,1:17]
	names <- y[,1]
	y <- y[,2:(max + 2)]	
	y <- y / 60
	#z <- z[,2:(max + 2)]
	#z <- z * 5000000	
	#z <- 5000000

#	par(fig=c(0.53,0.99,0,1), oma=c(0.0, 0.0, 0.0, 0.0), mar=c(5.1, 4.5, 4.1, 0.0), new=TRUE)
	yl = "runtime [min]"
#	yl = "time for 5mio correctly mapped [min]"
#	yl = "correctly mapped per min"
	yli = c(0,100)
#	yli = c(0,200000000)
	plot(1, xlim=c(0,max),ylim=yli, main="Runtime", xlab=xaxis[i], ylab=yl, axes=F,cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, type="n")

	names <- c("NextGenMap", "NextGenMap", "Bowtie2", "BWA-SW", "Stampy", "BWA", "NextGenMap (old)", "NextGenMap (old)")
	ltypes <- c(1,1,1,1,1)
	xtext <- c(2.5, 2.5, 9, 7, 9.5, 2.5, 2, 2)
	ytext <- c(-1.5, -1.5, -0.5, 12, 95, 14, 20, 20)

	for(i in c()) {
	#for(i in c(3,4,6)) { #bwa/bowtie
	#for(i in c(3,4,5,6)) { #bwa/bowtie/stampy
	#for(i in c(3,4,5,6,8)) { #bwa/bowtie/stampy/old
	#for(i in c(3,4,5,6,8,1,2)) { #all
#		r = y[i,]/z[i,] * 5000000
#		r = z[i,]/y[i,]
		r = y[i,]
		lines(x, r, xlim=c(0,max),ylim=c(0,100), cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, col=colors[i],  lty=ltys[i], type="l")
		text(xtext[i], ytext[i], names[i], col=colors[i], cex=1.5)
	}
	axis(side=1, cex.axis=2.0) 
	axis(side=2, cex.axis=2.0) 

	#names <- c("NGM (GPU)", "NGM (CPU)", "Bowtie2", "BWA-SW", "Stampy", "BWA")
	#legend(6.5,70,names, col=colors, cex=1.5, lwd=2, lty=ltys)
	#legend(3.2,200000000,names, col=colors, cex=1.5, lwd=2, lty=ltys)
	#dev.off()
#}
dev.off()
	
	
x11(width=8, height=6)
#pdf("adb-poly-all-2kmer.pdf", width=8, height=6)
pdf("adb-poly-0.pdf", width=8, height=6)
#Mapping results
files  <- c("summary-100bp-subst.txt", "summary-100bp-indel.txt", "summary-100bp-distance.txt")
files2  <- c("summary-100bp-wrong-subst.txt", "summary-100bp-wrong-indel.txt", "summary-100bp-wrong-distance.txt")
output <- c("plots/100bp-subst.pdf", "plots/100bp-indel.pdf", "plots/100bp-distance.pdf")
xaxis <- c("substitutions per 100 bp", "indels per 100 bp", "divergence [%]")

#for(i in 1:length(files)) {
	#i <- 3
	#pdf(output[i], width=7, height=9)

	i <- 3
	y <- read.table(files[i], header=TRUE, sep='\t')[,1:17]
	names <- y[,1]
	y <- y[,2:(max + 2)]
	
	y2 <- read.table(files2[i], header=TRUE, sep='\t')[,1:17]
	names <- y2[,1]
	y2 <- y2[,2:(max + 2)]

#	par(fig=c(0,0.53,0,1), oma=c(0.0, 0.0, 0.0, 0.0), mar=c(5.1, 4.5, 4.1, 4.1), new=TRUE)
	par(oma=c(0.0, 0.0, 0.0, 0.0), mar=c(5.1, 4.5, 4.1, 4.1))
	pchars <- c(0,1,2,3,4)
	
	plot(1, xlim=c(0,max),ylim=c(0,100), xlab=xaxis[i], ylab="correctly mapped [%]", axes=F,cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, type="n")

	names <- c("NextGenMap", "NextGenMap", "Bowtie2", "BWA-SW", "Stampy", "BWA", "NextGenMap (old)")
	ltypes <- c(1,1,1,1,1)
	xtext <- c(6, 6, 5.5, 9, 9.5, 1.5, 8.5)
	ytext <- c(101, 101, 60, 60, 101, 60, 88)

	for(i in c()) {
	#for(i in c(3,4,6)) { #bwa/bowtie
	#for(i in c(3,4,5,6)) { #bwa/bowtie/stampy
	#for(i in c(3,4,5,6,7)) { #bwa/bowtie/stampy/old
	#for(i in c(3,4,5,6,7,1)) { #all
		lines(x, y[i,], xlim=c(0,max),ylim=c(0,100), cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, col=colors[i],  lty=1, type="l")#, pch=pchars[i])
		#lines(x, y2[i,], xlim=c(0,max),ylim=c(0,100), cex.axis=2.0, cex.lab=2.0, cex.main=2.0, lwd=2, col=colors[i],  lty=2, type="l")#, pch=pchars[i])
		text(xtext[i], ytext[i], names[i], col=colors[i], cex=1.5)
	}
	axis(side=1, cex.axis=2.0) 
	axis(side=2, cex.axis=2.0) 

	#axis(side=4, lty=2, pos=(max + 0.5), cex.axis=2.0)
	#mtext("incorrectly mapped [%]", side = 4, line = 3, cex=2.0)

#text(5.5, 60, "Bowtie2", col=colors[3], cex=1.5)
#text(9, 60, "BWA-SW", col=colors[4], cex=1.5)
#text(1.5, 60, "BWA", col=colors[6], cex=1.5)
#text(9.5, 101, "Stampy", col=colors[5], cex=1.5)
#text(8, 90, "NextGenMap", col=colors[2], cex=1.5)

#text(5, 101, "NextGenMap (t=2)", col='black', cex=1.5)

	#names <- c("ngm", "bowtie2", "bwasw", "stampy", "bwa")
	#ltypes <- c(1,1,1,1,1)
	#legend(0,40,names, col=colors, lty=ltypes, cex=1.5, lwd=2)
	
	#dev.off()
#}

dev.off()


